Index: branches/1.3/examples/zoo/mesh/Makefile.in
===================================================================
--- branches/1.3/examples/zoo/mesh/Makefile.in	(revision 3748)
+++ branches/1.3/examples/zoo/mesh/Makefile.in	(revision 3752)
@@ -16,10 +16,14 @@
 
 FILES		= \
-		$(srcdir)/data.tcl \
-		$(srcdir)/datatri.tcl \
 		$(srcdir)/file.vtk \
+		$(srcdir)/mesh.m \
 		$(srcdir)/mesh.tcl \
 		$(srcdir)/mesh.vtk \
-		$(srcdir)/tool.xml
+		$(srcdir)/particle_data.txt \
+		$(srcdir)/points.txt \
+		$(srcdir)/substrate_data.txt \
+		$(srcdir)/tool.xml \
+		$(srcdir)/tool_octave.xml \
+		$(srcdir)/triangles.txt
 
 destdir		= $(prefix)/examples/zoo/mesh
Index: branches/1.3/examples/zoo/mesh/mesh.m
===================================================================
--- branches/1.3/examples/zoo/mesh/mesh.m	(revision 3748)
+++ branches/1.3/examples/zoo/mesh/mesh.m	(revision 3752)
@@ -3,6 +3,6 @@
 lib = rpLib(infile);
 
-meshtype = rpLibGetString(lib, 'input.choice.current');
-contour = rpLibGetString(lib, 'input.boolean.current')
+meshtype = rpLibGetString(lib, 'input.choice(mesh).current');
+contour = rpLibGetString(lib, 'input.boolean(contour).current')
 switch contour 
   case 'yes'
Index: branches/1.3/examples/zoo/mesh/mesh.tcl
===================================================================
--- branches/1.3/examples/zoo/mesh/mesh.tcl	(revision 3748)
+++ branches/1.3/examples/zoo/mesh/mesh.tcl	(revision 3752)
@@ -10,6 +10,6 @@
 set driver [Rappture::library [lindex $argv 0]]
 
-set meshtype [$driver get input.choice.current]
-set contour [$driver get input.boolean.current]
+set meshtype [$driver get "input.choice(mesh).current"]
+set contour [$driver get "input.boolean(contour).current"]
 if { $contour  == "yes" } {
     set view contour
Index: branches/1.3/examples/zoo/mesh/tool.xml
===================================================================
--- branches/1.3/examples/zoo/mesh/tool.xml	(revision 3748)
+++ branches/1.3/examples/zoo/mesh/tool.xml	(revision 3752)
@@ -79,4 +79,11 @@
     <default>triangular</default>
    </choice>
+   <boolean id="contour">
+     <about>
+       <label>Contour Plot</label>
+       <description>Display as a contour plot or surface plot</description>
+     </about>
+     <default>yes</default>
+   </boolean>
  </input>
 </run>
Index: branches/1.3/examples/zoo/mesh/tool2.xml
===================================================================
--- branches/1.3/examples/zoo/mesh/tool2.xml	(revision 3748)
+++ 	(revision )
@@ -1,90 +1,0 @@
-<?xml version="1.0"?>
-<run>
- <tool>
-  <about>Press Simulate to view results.</about>
-  <command>octave --silent --eval "infile='@driver',path('@tool',path),mesh"</command>
- </tool>
- <input>
-   <choice id="mesh">
-    </option>
-    <option>
-     <about>
-      <label>mesh as cloud</label>
-      <description>2 dimensional cloud of points.</description>
-     </about>
-     <value>cloud</value>
-    </option>
-    <option>
-     <about>
-      <label>mesh as uniform grid</label>
-      <description>uniform 2 dimensional grid of points.</description>
-     </about>
-     <value>regular</value>
-    </option>
-    <option>
-     <about>
-      <label>mesh as irregular grid</label>
-      <description>irregular 2 dimensional grid of points.</description>
-     </about>
-     <value>irregular</value>
-    </option>
-    <option>
-     <about>
-      <label>mesh as hybrid irregular/regular grid</label>
-      <description>Hybrid 2 dimensional grid of points X (irregular), Y (regular).</description>
-     </about>
-     <value>hybrid</value>
-    </option>
-    <option>
-     <about>
-      <label>mesh as triangular grid</label>
-      <description>Triangular 2 dimensional grid.</description>
-     </about>
-     <value>triangular</value>
-    </option>
-    <option>
-     <about>
-      <label>mesh as hybid cell types</label>
-      <description>Unstructured 2D grid of (possibly) hybrid cells.</description>
-     </about>
-     <value>cells</value>
-    </option>
-    <option>
-     <about>
-      <label>mesh as unstructured grid</label>
-      <description>Unstructured 2D grid.</description>
-     </about>
-     <value>unstructured</value>
-    </option>
-    <option>
-     <about>
-      <label>general nodes and elements description</label>
-      <description>Unstructured 2 dimensional grid of cells using nodes and elements.</description>
-     </about>
-     <value>generic</value>
-    </option>
-    <option>
-     <about>
-      <label>VTK mesh</label>
-      <description>Partial VTK file representing the mesh.</description>
-     </about>
-     <value>vtkmesh</value>
-    </option>
-    <option>
-     <about>
-      <label>VTK format (field + mesh)</label>
-      <description>Single VTK file representing both the mesh and field.</description>
-     </about>
-     <value>vtkfield</value>
-    </option>
-    <default>triangular</default>
-   </choice>
- <boolean>
-   <about>
-     <label>Contour Plot</label>
-     <description>Display as a contour plot or surface plot</description>
-   </about>
-   <default>yes</default>
- </boolean>
- </input>
-</run>
Index: branches/1.3/examples/zoo/mesh/tool_octave.xml
===================================================================
--- branches/1.3/examples/zoo/mesh/tool_octave.xml	(revision 3752)
+++ branches/1.3/examples/zoo/mesh/tool_octave.xml	(revision 3752)
@@ -0,0 +1,89 @@
+<?xml version="1.0"?>
+<run>
+ <tool>
+  <about>Press Simulate to view results.</about>
+  <command>octave --silent --eval "infile='@driver',path('@tool',path),mesh"</command>
+ </tool>
+ <input>
+   <choice id="mesh">
+    <option>
+     <about>
+      <label>mesh as cloud</label>
+      <description>2 dimensional cloud of points.</description>
+     </about>
+     <value>cloud</value>
+    </option>
+    <option>
+     <about>
+      <label>mesh as uniform grid</label>
+      <description>uniform 2 dimensional grid of points.</description>
+     </about>
+     <value>regular</value>
+    </option>
+    <option>
+     <about>
+      <label>mesh as irregular grid</label>
+      <description>irregular 2 dimensional grid of points.</description>
+     </about>
+     <value>irregular</value>
+    </option>
+    <option>
+     <about>
+      <label>mesh as hybrid irregular/regular grid</label>
+      <description>Hybrid 2 dimensional grid of points X (irregular), Y (regular).</description>
+     </about>
+     <value>hybrid</value>
+    </option>
+    <option>
+     <about>
+      <label>mesh as triangular grid</label>
+      <description>Triangular 2 dimensional grid.</description>
+     </about>
+     <value>triangular</value>
+    </option>
+    <option>
+     <about>
+      <label>mesh as hybid cell types</label>
+      <description>Unstructured 2D grid of (possibly) hybrid cells.</description>
+     </about>
+     <value>cells</value>
+    </option>
+    <option>
+     <about>
+      <label>mesh as unstructured grid</label>
+      <description>Unstructured 2D grid.</description>
+     </about>
+     <value>unstructured</value>
+    </option>
+    <option>
+     <about>
+      <label>general nodes and elements description</label>
+      <description>Unstructured 2 dimensional grid of cells using nodes and elements.</description>
+     </about>
+     <value>generic</value>
+    </option>
+    <option>
+     <about>
+      <label>VTK mesh</label>
+      <description>Partial VTK file representing the mesh.</description>
+     </about>
+     <value>vtkmesh</value>
+    </option>
+    <option>
+     <about>
+      <label>VTK format (field + mesh)</label>
+      <description>Single VTK file representing both the mesh and field.</description>
+     </about>
+     <value>vtkfield</value>
+    </option>
+    <default>triangular</default>
+   </choice>
+   <boolean id="contour">
+     <about>
+       <label>Contour Plot</label>
+       <description>Display as a contour plot or surface plot</description>
+     </about>
+     <default>yes</default>
+   </boolean>
+ </input>
+</run>