Index: /trunk/packages/vizservers/vtkvis/Makefile.in
===================================================================
--- /trunk/packages/vizservers/vtkvis/Makefile.in	(revision 4039)
+++ /trunk/packages/vizservers/vtkvis/Makefile.in	(revision 4040)
@@ -2,5 +2,5 @@
 TRACE			= #yes
 USE_CUSTOM_AXES		= yes
-USE_FONT_CONFIG         = #yes
+USE_FONT_CONFIG         = yes
 USE_GPU_RAYCASTING	= yes
 USE_OFFSCREEN_RENDERING	= #yes
@@ -125,9 +125,10 @@
 DEFINES         += -DUSE_THREADS
 endif
+ifdef NEW_SCALAR_BAR
+DEFINES		+= -DNEW_SCALAR_BAR
+endif
+
 VTK_MOD_DEFS    = -DvtkRenderingCore_AUTOINIT="4(vtkInteractionStyle,vtkRenderingFreeType,vtkRenderingFreeTypeOpenGL,vtkRenderingOpenGL)" -DvtkRenderingFreeType_AUTOINIT="1(vtkRenderingFreeTypeFontConfig)" -DvtkRenderingVolume_AUTOINIT="1(vtkRenderingVolumeOpenGL)"
 DEFINES         += -DUSE_VTK6 $(VTK_MOD_DEFS)
-ifdef NEW_SCALAR_BAR
-DEFINES		+= -DNEW_SCALAR_BAR
-endif
 
 CXX_SWITCHES	= $(CXXFLAGS) $(EXTRA_CXXFLAGS) $(DEFINES) $(INCLUDES)
Index: /trunk/packages/vizservers/vtkvis/RenderServer.h
===================================================================
--- /trunk/packages/vizservers/vtkvis/RenderServer.h	(revision 4039)
+++ /trunk/packages/vizservers/vtkvis/RenderServer.h	(revision 4040)
@@ -16,5 +16,5 @@
 class Renderer;
 
-#define VTKVIS_VERSION_STRING "1.6"
+#define VTKVIS_VERSION_STRING "1.7"
 
 #define MSECS_ELAPSED(t1, t2) \
Index: /trunk/packages/vizservers/vtkvis/RendererCmd.cpp
===================================================================
--- /trunk/packages/vizservers/vtkvis/RendererCmd.cpp	(revision 4039)
+++ /trunk/packages/vizservers/vtkvis/RendererCmd.cpp	(revision 4040)
@@ -10194,4 +10194,30 @@
     }
     g_renderer->setUseDepthPeeling(state);
+    if (objc > 3) {
+        if (objc < 5) {
+             Tcl_AppendResult(interp, "wrong # args: should be \"", Tcl_GetString(objv[0]),
+                              " ", Tcl_GetString(objv[1]), " bool ?occlusionRatio maxPeels?\"", (char*)NULL);
+            return TCL_ERROR;
+        }
+        double occlusionRatio;
+        int maxPeels;
+        if (Tcl_GetDoubleFromObj(interp, objv[3], &occlusionRatio) != TCL_OK) {
+            return TCL_ERROR;
+        }
+        if (occlusionRatio < 0.0 || occlusionRatio > 0.5) {
+            Tcl_AppendResult(interp, "bad occlusionRatio value \"", Tcl_GetString(objv[3]),
+                             "\": should be [0,0.5]", (char*)NULL);
+            return TCL_ERROR;
+        }
+        if (Tcl_GetIntFromObj(interp, objv[4], &maxPeels) != TCL_OK) {
+            return TCL_ERROR;
+        }
+        if (maxPeels < 0) {
+            Tcl_AppendResult(interp, "bad maxPeels value \"", Tcl_GetString(objv[3]),
+                             "\": must be zero or greater", (char*)NULL);
+            return TCL_ERROR;
+        }
+        g_renderer->setDepthPeelingParams(occlusionRatio, maxPeels);
+    }
     return TCL_OK;
 }
@@ -10235,5 +10261,5 @@
 static Rappture::CmdSpec rendererOps[] = {
     {"clipplane",  1, RendererClipPlaneOp, 5, 5, "axis ratio direction"},
-    {"depthpeel",  1, RendererDepthPeelingOp, 3, 3, "bool"},
+    {"depthpeel",  1, RendererDepthPeelingOp, 3, 5, "bool ?occlusionRatio maxPeels?"},
     {"light2side", 6, RendererTwoSidedLightingOp, 3, 3, "bool"},
     {"lights",     6, RendererLightsOp, 4, 4, "idx bool"}, 
Index: /trunk/packages/vizservers/vtkvis/protocol.txt
===================================================================
--- /trunk/packages/vizservers/vtkvis/protocol.txt	(revision 4039)
+++ /trunk/packages/vizservers/vtkvis/protocol.txt	(revision 4040)
@@ -3,5 +3,5 @@
 Protocol for vtkvis render server.  
 
-Commands take the general form of command and arguments using Tcl syntax and are 
+Commands take the general form of command and arguments using Tcl syntax and are
 terminated by a newline.  Some command arguments expect a Tcl list which can be
 sent by enclosing the list in curly braces to prevent the interpreter from 
@@ -125,6 +125,6 @@
      <max> = maximum value of axis for labels
 axis scale <axis> <scale>
-     Set axis range to be computed based on scaling the axis bounds by the
-     given scale factor.
+     Set axis range to be computed based on scaling the axis bounds by the given
+     scale factor.
      <axis> = x|y|z|all
      <scale> = scale factor where range = bounds * scale
@@ -247,6 +247,14 @@
          direction determines normal of clipping plane.  User clip planes do not
          apply if camera mode is image.
-renderer depthpeel <bool>
+renderer depthpeel <bool> <?occlusionRatio?> <?maxPeels?>
          Set use of depth peeling algorithm for transparency
+         <occlusionRatio> = [0,0.5] Value of 0 means exact rendering, higher
+         values can speed rendering at the cost of some quality.  From VTK docs:
+         "the threshold under which the algorithm stops to iterate over peel 
+         layers. This is the ratio of the number of pixels that have been 
+         touched by the last layer over the total number of pixels of the 
+         viewport area."
+         <maxPeels> = 0 means unlimited passes, positive value limits the number
+         of rendering passes 
 renderer light2side <bool>
          Toggle use of two-sided lighting (controls if backfaces are lit with a