Index: /trunk/packages/vizservers/geovis/CmdProc.cpp
===================================================================
--- /trunk/packages/vizservers/geovis/CmdProc.cpp	(revision 4056)
+++ /trunk/packages/vizservers/geovis/CmdProc.cpp	(revision 4057)
@@ -11,5 +11,5 @@
 #include "CmdProc.h"
 
-using namespace Rappture;
+using namespace GeoVis;
 
 /**
@@ -116,14 +116,14 @@
  */
 Tcl_ObjCmdProc *
-Rappture::GetOpFromObj(Tcl_Interp *interp,	/* Interpreter to report errors to */
-                       int nSpecs,		/* Number of specifications in array */
-                       CmdSpec *specs,		/* Op specification array */
-                       int operPos,		/* Position of operation in argument
+GeoVis::GetOpFromObj(Tcl_Interp *interp,	/* Interpreter to report errors to */
+                     int nSpecs,		/* Number of specifications in array */
+                     CmdSpec *specs,		/* Op specification array */
+                     int operPos,		/* Position of operation in argument
                                                  * list. */
-                       int objc,		/* Number of arguments in the argument
+                     int objc,			/* Number of arguments in the argument
                                                  * vector.  This includes any prefixed
                                                  * arguments */ 
-                       Tcl_Obj *const *objv,	/* Argument vector */
-                       int flags)
+                     Tcl_Obj *const *objv,	/* Argument vector */
+                     int flags)
 {
     CmdSpec *specPtr;
Index: /trunk/packages/vizservers/geovis/CmdProc.h
===================================================================
--- /trunk/packages/vizservers/geovis/CmdProc.h	(revision 4056)
+++ /trunk/packages/vizservers/geovis/CmdProc.h	(revision 4057)
@@ -6,10 +6,10 @@
  */
 
-#ifndef RAPPTURE_CMDPROC_H
-#define RAPPTURE_CMDPROC_H
+#ifndef GEOVIS_CMDPROC_H
+#define GEOVIS_CMDPROC_H
 
 #include <tcl.h>
 
-namespace Rappture {
+namespace GeoVis {
 
 /**
@@ -43,5 +43,5 @@
              CmdSpec *specs, int operPos, int objc, Tcl_Obj *const *objv, int flags);
 
-#define NumCmdSpecs(s) (sizeof(s) / sizeof(Rappture::CmdSpec))
+#define NumCmdSpecs(s) (sizeof(s) / sizeof(GeoVis::CmdSpec))
 
 }
Index: /trunk/packages/vizservers/geovis/RendererCmd.cpp
===================================================================
--- /trunk/packages/vizservers/geovis/RendererCmd.cpp	(revision 4056)
+++ /trunk/packages/vizservers/geovis/RendererCmd.cpp	(revision 4057)
@@ -232,5 +232,5 @@
 }
 
-static Rappture::CmdSpec cameraOps[] = {
+static CmdSpec cameraOps[] = {
     {"orient", 1, CameraOrientOp, 6, 6, "qw qx qy qz"},
     {"pan",    1, CameraPanOp, 4, 4, "panX panY"},
@@ -248,6 +248,6 @@
     Tcl_ObjCmdProc *proc;
 
-    proc = Rappture::GetOpFromObj(interp, nCameraOps, cameraOps,
-                                  Rappture::CMDSPEC_ARG1, objc, objv, 0);
+    proc = GetOpFromObj(interp, nCameraOps, cameraOps,
+                        CMDSPEC_ARG1, objc, objv, 0);
     if (proc == NULL) {
         return TCL_ERROR;
@@ -365,5 +365,5 @@
 }
 
-static Rappture::CmdSpec keyOps[] = {
+static CmdSpec keyOps[] = {
     {"press",    1, KeyPressOp,       3, 3, "key"},
     {"release",  1, KeyReleaseOp,     3, 3, "key"},
@@ -377,6 +377,6 @@
     Tcl_ObjCmdProc *proc;
 
-    proc = Rappture::GetOpFromObj(interp, nKeyOps, keyOps,
-                                  Rappture::CMDSPEC_ARG1, objc, objv, 0);
+    proc = GetOpFromObj(interp, nKeyOps, keyOps,
+                        CMDSPEC_ARG1, objc, objv, 0);
     if (proc == NULL) {
         return TCL_ERROR;
@@ -505,5 +505,5 @@
 }
 
-static Rappture::CmdSpec mapLayerOps[] = {
+static CmdSpec mapLayerOps[] = {
     {"add",     1, MapLayerAddOp,       6, 6, "type url name"},
     {"delete",  1, MapLayerDeleteOp,    3, 4, "?name?"},
@@ -520,6 +520,6 @@
     Tcl_ObjCmdProc *proc;
 
-    proc = Rappture::GetOpFromObj(interp, nMapLayerOps, mapLayerOps,
-                                  Rappture::CMDSPEC_ARG2, objc, objv, 0);
+    proc = GetOpFromObj(interp, nMapLayerOps, mapLayerOps,
+                        CMDSPEC_ARG2, objc, objv, 0);
     if (proc == NULL) {
         return TCL_ERROR;
@@ -593,5 +593,5 @@
 }
 
-static Rappture::CmdSpec mapOps[] = {
+static CmdSpec mapOps[] = {
     {"layer",    2, MapLayerOp,       3, 6, "op ?params...?"},
     {"load",     2, MapLoadOp,        4, 5, "options"},
@@ -606,6 +606,6 @@
     Tcl_ObjCmdProc *proc;
 
-    proc = Rappture::GetOpFromObj(interp, nMapOps, mapOps,
-                                  Rappture::CMDSPEC_ARG1, objc, objv, 0);
+    proc = GetOpFromObj(interp, nMapOps, mapOps,
+                        CMDSPEC_ARG1, objc, objv, 0);
     if (proc == NULL) {
         return TCL_ERROR;
@@ -719,5 +719,5 @@
 }
 
-static Rappture::CmdSpec mouseOps[] = {
+static CmdSpec mouseOps[] = {
     {"click",    1, MouseClickOp,       5, 5, "button x y"},
     {"dblclick", 2, MouseDoubleClickOp, 5, 5, "button x y"},
@@ -735,6 +735,6 @@
     Tcl_ObjCmdProc *proc;
 
-    proc = Rappture::GetOpFromObj(interp, nMouseOps, mouseOps,
-                                  Rappture::CMDSPEC_ARG1, objc, objv, 0);
+    proc = GetOpFromObj(interp, nMouseOps, mouseOps,
+                        CMDSPEC_ARG1, objc, objv, 0);
     if (proc == NULL) {
         return TCL_ERROR;
@@ -751,5 +751,5 @@
 }
 
-static Rappture::CmdSpec rendererOps[] = {
+static CmdSpec rendererOps[] = {
     {"render",     1, RendererRenderOp, 2, 2, ""},
 };
@@ -762,6 +762,6 @@
     Tcl_ObjCmdProc *proc;
 
-    proc = Rappture::GetOpFromObj(interp, nRendererOps, rendererOps,
-                                  Rappture::CMDSPEC_ARG1, objc, objv, 0);
+    proc = GetOpFromObj(interp, nRendererOps, rendererOps,
+                        CMDSPEC_ARG1, objc, objv, 0);
     if (proc == NULL) {
         return TCL_ERROR;
@@ -801,5 +801,5 @@
 }
 
-static Rappture::CmdSpec screenOps[] = {
+static CmdSpec screenOps[] = {
     {"bgcolor", 1, ScreenBgColorOp, 5, 5, "r g b"},
     {"size", 1, ScreenSizeOp, 4, 4, "width height"}
@@ -813,6 +813,6 @@
     Tcl_ObjCmdProc *proc;
 
-    proc = Rappture::GetOpFromObj(interp, nScreenOps, screenOps,
-                                  Rappture::CMDSPEC_ARG1, objc, objv, 0);
+    proc = GetOpFromObj(interp, nScreenOps, screenOps,
+                        CMDSPEC_ARG1, objc, objv, 0);
     if (proc == NULL) {
         return TCL_ERROR;
Index: /trunk/packages/vizservers/geovis/configure
===================================================================
--- /trunk/packages/vizservers/geovis/configure	(revision 4056)
+++ /trunk/packages/vizservers/geovis/configure	(revision 4057)
@@ -636,7 +636,4 @@
 SHLIB_LD
 SHLIB_CFLAGS
-RP_LIB_DIR
-RP_INC_SPEC
-RP_DIR
 LD_RPATH
 CFLAGS_OPTIMIZE
@@ -705,5 +702,4 @@
 enable_option_checking
 with_tcllib
-with_rappture
 with_osg_includes
 with_osg_libs
@@ -1339,6 +1335,4 @@
   --with-tcllib=DIR       location of Tcl binary library libtclstubs.a
                           [default=/usr/lib]
-  --with-rappture=DIR     location of rappture files lib/librappture.a and
-                          include/rappture.h [default=/usr]
   --with-osg-includes=DIR OSG include files are in DIR
   --with-osg-libs=DIR     OSG libraries are in DIR
@@ -2304,13 +2298,4 @@
 
 
-# Check whether --with-rappture was given.
-if test "${with_rappture+set}" = set; then :
-  withval=$with_rappture; with_rappture=$withval
-else
-  with_rappture=yes
-fi
-
-
-
 # Check whether --with-osg-includes was given.
 if test "${with_osg_includes+set}" = set; then :
@@ -5059,6 +5044,5 @@
 #
 # Need to check for the following dependencies:
-#	Rappture headers and library (done)
-#       Tcl headers and library (done)
+#       Tcl headers and library
 #       GL headers and library
 #       pthread library
@@ -5070,7 +5054,5 @@
 for dir in \
  ${exec_prefix} \
- ${exec_prefix}/lib \
- ${with_rappture} \
- ${with_rappture}/lib ; do
+ ${exec_prefix}/lib ; do
   tclconfig="${dir}/tclConfig.sh"
   if test -f "$tclconfig" ; then
@@ -5090,34 +5072,4 @@
 if test "x$with_tclinclude" != "x" ; then
    TCL_INC_SPEC="-I${with_tclinclude}"
-fi
-
-RP_DIR=""
-{ $as_echo "$as_me:${as_lineno-$LINENO}: checking for rappture" >&5
-$as_echo_n "checking for rappture... " >&6; }
-if test "$with_rappture" == "yes" ; then
-  for dir in "$exec_prefix" "/usr" ; do
-    if test -r "$dir/include/rappture2/rappture2.h" -a \
-     -r "$dir/lib/librappture.a"; then
-      RP_DIR="$dir"
-      RP_INC_SPEC="-I$dir/include -I$dir/include/rappture2"
-      RP_LIB_DIR="$dir/lib"
-      { $as_echo "$as_me:${as_lineno-$LINENO}: result: $dir" >&5
-$as_echo "$dir" >&6; }
-      break
-    fi
-  done
-else
-  if test ! -d "$with_rappture" ; then
-    as_fn_error $? "--with-rappture: no such directory $with_rappture" "$LINENO" 5
-  fi
-  RP_DIR=$with_rappture
-  RP_INC_SPEC="-I$with_rappture/include -I$with_rappture/include/rappture2"
-  RP_LIB_DIR="$with_rappture/lib"
-fi
-if test "x${RP_DIR}" = "x" ; then
-  as_fn_error $? "cannot find rappture.h and librappture2.a, try using --with-rappture" "$LINENO" 5
-else
-  { $as_echo "$as_me:${as_lineno-$LINENO}: result: $with_rappture" >&5
-$as_echo "$with_rappture" >&6; }
 fi
 
@@ -5433,7 +5385,4 @@
 fi
 done
-
-
-
 
 
Index: /trunk/packages/vizservers/geovis/configure.in
===================================================================
--- /trunk/packages/vizservers/geovis/configure.in	(revision 4056)
+++ /trunk/packages/vizservers/geovis/configure.in	(revision 4057)
@@ -9,11 +9,4 @@
     [with_tcllib=$withval],
     [with_tcllib=""])
-
-AC_ARG_WITH(
-    [rappture],
-    [AS_HELP_STRING([--with-rappture[=DIR]],
-        [location of rappture files lib/librappture.a and include/rappture.h @<:@default=/usr@:>@])],
-    [with_rappture=$withval],
-    [with_rappture=yes])
 
 AC_ARG_WITH(
@@ -81,6 +74,5 @@
 #
 # Need to check for the following dependencies:
-#	Rappture headers and library (done)
-#       Tcl headers and library (done)
+#       Tcl headers and library
 #       GL headers and library
 #       pthread library
@@ -92,7 +84,5 @@
 for dir in \
  ${exec_prefix} \
- ${exec_prefix}/lib \
- ${with_rappture} \
- ${with_rappture}/lib ; do
+ ${exec_prefix}/lib ; do
   tclconfig="${dir}/tclConfig.sh"
   if test -f "$tclconfig" ; then
@@ -112,31 +102,4 @@
 if test "x$with_tclinclude" != "x" ; then
    TCL_INC_SPEC="-I${with_tclinclude}"
-fi
-
-RP_DIR=""
-AC_MSG_CHECKING([for rappture])
-if test "$with_rappture" == "yes" ; then
-  for dir in "$exec_prefix" "/usr" ; do
-    if test -r "$dir/include/rappture2/rappture2.h" -a \
-     -r "$dir/lib/librappture.a"; then
-      RP_DIR="$dir"
-      RP_INC_SPEC="-I$dir/include -I$dir/include/rappture2"
-      RP_LIB_DIR="$dir/lib"
-      AC_MSG_RESULT([$dir])
-      break
-    fi
-  done
-else
-  if test ! -d "$with_rappture" ; then 
-    AC_MSG_ERROR([--with-rappture: no such directory $with_rappture])
-  fi
-  RP_DIR=$with_rappture
-  RP_INC_SPEC="-I$with_rappture/include -I$with_rappture/include/rappture2"
-  RP_LIB_DIR="$with_rappture/lib"
-fi
-if test "x${RP_DIR}" = "x" ; then
-  AC_MSG_ERROR([cannot find rappture.h and librappture2.a, try using --with-rappture])
-else
-  AC_MSG_RESULT([$with_rappture])
 fi
 
@@ -162,7 +125,4 @@
 AC_SUBST(CFLAGS_OPTIMIZE)
 AC_SUBST(LD_RPATH)
-AC_SUBST(RP_DIR)
-AC_SUBST(RP_INC_SPEC)
-AC_SUBST(RP_LIB_DIR)
 AC_SUBST(SHLIB_CFLAGS)
 AC_SUBST(SHLIB_LD)